

;	BASIC LINE AND COMMAND INTERPRETATION

;	THE SYNTAX TABLES

;	i. The offset table
;There is an offset value for each of the fifty BASIC commands.
L1A48:	
	DB	0B1H	;DEF FN		L1AF9
	DB	0CBH	;CAT		L1B14
	DB	0BCH	;FORMAT		L1B06
	DB	0BFH	;MOVE		L1B0A
	DB	0C4H	;ERASE		L1B10
	DB	0AFH	;OPEN #		L1AFC
	DB	0B4H	;CLOSE #	L1B02
	DB	93H	;MERGE		L1AE2
	DB	91H	;VERIFY		L1AE1
	DB	92H	;BEEP		L1AE3
	DB	95H	;CIRCLE		L1AE7
	DB	98H	;INK		L1AEB
	DB	98H	;PAPER		L1AEC
	DB	98H	;FLASH		L1AED
	DB	98H	;BRIGHT		L1AEE
	DB	98H	;INVERSE	L1AEF
	DB	98H	;OVER		L1AF0
	DB	98H	;OUT		L1AF1
	DB	7FH	;LPRINT		L1AD9
	DB	81H	;LLIST		L1ADC
	DB	2EH	;STOP		L1A8A
	DB	6CH	;READ		L1AC9
	DB	6EH	;DATA		L1ACC
	DB	70H	;RESTORE	L1ACF
	DB	48H	;NEW		L1AA8
	DB	94H	;BORDER		L1AF5
	DB	56H	;CONTINUE	L1AB8
	DB	3FH	;DIM		L1AA2
	DB	41H	;REM		L1AA5
	DB	2BH	;FOR		L1A90
	DB	17H	;GO TO		L1A7D
	DB	1FH	;GO SUB		L1A86
	DB	37H	;INPUT		L1A9F
	DB	77H	;LOAD		L1AE0
	DB	44H	;LIST		L1AAE
	DB	0FH	;LET		L1A7A
	DB	59H	;PAUSE		L1AC5
	DB	2BH	;NEXT		L1A98
	DB	43H	;POKE		L1AB1
	DB	2DH	;PRINT		L1A9C
	DB	51H	;PLOT		L1AC1
	DB	3AH	;RUN		L1AAB
	DB	6DH	;SAVE		L1ADF
	DB	42H	;RANDOMIZE	L1AB5
	DB	0DH	;IF		L1A81
	DB	49H	;CLS		L1ABE
	DB	5CH	;DRAW		L1AD2
	DB	44H	;CLEAR		L1ABB
	DB	15H	;RETURN		L1A8D
	DB	5DH	;COPY		L1AD6

;	ii. The parameter table
;For each of the fifty BASIC commands there are up to eight entries in the
;parameter table. These entries comprise command class details, required
;separators and, where appropriate, command routine addrs.
L1A7A:;P_LET
	DB	01H	;CLASS-01
	DB	3DH	;'='
	DB	02H	;CLASS-02
L1A7D:;P_GO_TO
	DB	06H	;CLASS-06
	DB	00H	;CLASS-00
	DB	67H,1EH	;GO_TO
L1A81:;P_IF
	DB	06H	;CLASS-06
	DB	0CBH	;'THEN'
	DB	05H	;CLASS-05
	DB	0F0H,1CH;IF
L1A86:;P_GO_SUB
	DB	06H	;CLASS-06
	DB	00H	;CLASS-00
	DB	0EDH,1EH;GO_SUB
L1A8A:;P_STOP
	DB	00H	;CLASS-00
	DB	0EEH,1CH;STOP
L1A8D:;P_RETURN
	DB	00H	;CLASS-00
	DB	23H,1FH	;RETURN
L1A90:;P_FOR
	DB	04H	;CLASS-04
	DB	3DH	;'='
	DB	06H	;CLASS-06
	DB	0CCH	;'TO'
	DB	06H	;CLASS-06
	DB	05H	;CLASS-05
	DB	03H,1DH	;FOR
L1A98:;P_NEXT
	DB	04H	;CLASS-04
	DB	00H	;CLASS-00
	DB	0ABH,1DH;NEXT
L1A9C:;P_PRINT
	DB	05H	;CLASS-05
	DB	0CDH,1FH;PRINT
L1A9F:;P_INPUT
	DB	05H	;CLASS-05
	DB	89H,20H	;INPUT
L1AA2:;P_DIM
	DB	05H	;CLASS-05
	DB	02H,2CH	;DIM
L1AA5:;P_REM
	DB	05H	;CLASS-05
	DB	0B2H,1BH;REM
L1AA8:;P_NEW
	DB	00H	;CLASS-00
	DB	0B7H,11H;NEW
L1AAB:;P_RUN
	DB	03H	;CLASS-03
	DB	0A1H,1EH;RUN
L1AAE:;P_LIST
	DB	05H	;CLASS-05
	DB	0F9H,17H;LIST
L1AB1:;P_POKE
	DB	08H	;CLASS-08
	DB	00H	;CLASS-00
	DB	80H,1EH	;POKE
L1AB5:;P_RANDOM
	DB	03H	;CLASS-03
	DB	4FH,1EH	;RANDOMIZE
L1AB8:;P_CONT
	DB	00H	;CLASS-00
	DB	5FH,1EH	;CONTINUE
L1ABB:;P_CLEAR
	DB	03H	;CLASS-03
	DB	0ACH,1EH;CLEAR
L1ABE:;P_CLS
	DB	00H	;CLASS-00
	DB	6BH,0DH	;CLS
L1AC1:;P_PLOT
	DB	09H	;CLASS-09
	DB	00H	;CLASS-00
	DB	0DCH,22H;PLOT
L1AC5:;P_PAUSE
	DB	06H	;CLASS-06
	DB	00H	;CLASS-00
	DB	3AH,1FH	;PAUSE
L1AC8:;P_READ
	DB	05H	;CLASS-05
	DB	0EDH,1DH;READ
L1ACC:;P_DATA
	DB	05H	;CLASS-05
	DB	27H,1EH	;DATA
L1ACF:;P_RESTORE
	DB	03H	;CLASS-03
	DB	42H,1EH	;RESTORE
L1AD2:;P_DRAW
	DB	09H	;CLASS-09
	DB	05H	;CLASS-05
	DB	82H,23H	;DRAW
L1AD6:;P_COPY
	DB	00H	;CLASS-00
	DB	0ACH,0EH;COPY
L1AD9:;P_LPRINT
	DB	05H	;CLASS-05
	DB	0C9H,1FH;LPRINT
L1ADC:;P_LLIST
	DB	05H	;CLASS-05
	DB	0F5H,17H;LLIST
L1ADF:;P_SAVE
	DB	0BH	;CLASS-0B
L1AE0:;P_LOAD
	DB	0BH	;CLASS-0B
L1AE1:;P_VERIFY
	DB	0BH	;CLASS-0B
L1AE2:;P_MERGE
	DB	0BH	;CLASS-0B
L1AE3:;P_BEEP
	DB	08H	;CLASS-08
	DB	00H	;CLASS-00
	DB	0F8H,03H;BEEP
L1AE7:;P_CIRCLE
	DB	09H	;CLASS-09
	DB	05H	;CLASS-05
	DB	20H,23H	;CIRCLE
L1AEB:;P_INK
	DB	07H	;CLASS-07
L1AEC:;P_PAPER
	DB	07H	;CLASS-07
L1AED:;P_FLASH
	DB	07H	;CLASS-07
L1AEE:;P_BRIGHT
	DB	07H	;CLASS-07
L1AEF:;P_INVERSE
	DB	07H	;CLASS-07
L1AF0:;P_OVER
	DB	07H	;CLASS-07
L1AF1:;P_OUT
	DB	08H	;CLASS-08
	DB	00H	;CLASS-00
	DB	7AH,1EH	;OUT
L1AF5:;P_BORDER
	DB	06H	;CLASS-06
	DB	00H	;CLASS-00
	DB	94H,22H	;BORDER
L1AF9:;P_DEF_FN
	DB	05H	;CLASS-05
	DB	60H,1FH	;DEF_FN
L1AFC:;P_OPEN
	DB	06H	;CLASS-06
	DB	2CH	;','
	DB	0AH	;CLASS-0A
	DB	00H	;CLASS-00
	DB	36H,17H	;OPEN
L1B02:;P_CLOSE
	DB	06H	;CLASS-06
	DB	00H	;CLASS-00
	DB	0E5H,16H;CLOSE
L1B06:;P_FORMAT
	DB	0AH	;CLASS-0A
	DB	00H	;CLASS-00
	DB	93H,17H	;CAT_ETC
L1B0A:;P_MOVE
	DB	0AH	;CLASS-0A
	DB	2CH	;','
	DB	0AH	;CLASS-0A
	DB	00H	;CLASS-00
	DB	93H,17H	;CAT_ETC
L1B10:;P_ERASE
	DB	0AH	;CLASS-0A
	DB	00H	;CLASS-00
	DB	93H,17H	;CAT_ETC
L1B14:;P_CAT
	DB	00H	;CLASS-00
	DB	93H,17H	;CAT_ETC

;Note: The requirements for the different command classes are as follows:

;CLASS-00	No further operands.
;CLASS-01	Used in LET. A var is required.
;CLASS-02	Used in LET. An expression, numeric or string, must follow.
;CLASS-03	A numeric expression may follow. Zero to be used in case
;		of default.
;CLASS-04	A single char var must follow.
;CLASS-05	A set of items may be given.
;CLASS-06	A numeric expression must follow.
;CLASS-07	Handles colour items.
;CLASS-08	Two numeric expressions, separated by comma, must follow.
;CLASS-09	As for CLASS-08 but colour items may precede the expressions.
;CLASS-0A	A string expression must follow.
;CLASS-0B	Handles cassette routines.

;	THE 'MAIN PARSER' OF THE BASIC INTERPRETER
;The parsing routine of the BASIC interpreter is entered at LINE_SCAN when
;syntax is being checked, and at LINE_RUN when a BASIC program of one or
;more stmts is to be executed.
;  Each stmt is considered in turn and the system var CH_ADD is used to
;point to each code of the stmt as it occurs in the program area of the
;editing area.
L1B17:;LINE_SCAN
	RES	7,(IY+1);FLAGS	;Signal 'syntax checking'.
	CALL	L19FB;E_LINE_NO	;CH_ADD is made to point to the 1st code
				;after any line number.
	XOR	A		;The system var SUBPPC
	LD	(L5C47),A;SUBPPC ;is initialised to 00 and
	DEC	A		;ERR_NR to 0FFh.
	LD	(L5C3A),A;ERR_NR
	JR	L1B29;STMT_L_1

;	THE STATEMENT LOOP
;Each stmt is considered in turn until the end of the line is reached.
L1B28:;STMT_LOOP
	RST	20H;NEXT_CHAR	;Advance CH_ADD along the line.
L1B29:;STMT_L_1
	CALL	L16BF;SET_WORK	;The work space is cleared.
	INC	(IY+0DH);SUBPPC	;Increase SUBPPC on each passage around
				;the loop.
	JP	M,L1C8A;REPORT_C ;But only '127' stmts are allowed
				;in a single line.
	RST	18H;GET_CHAR	;Fetch a char.
	LD	B,0		;Clear the reg for later.
	CP	0DH		;Is the char a 'carriage return'?
	JR	Z,L1BB3;LINE_END ;Jump if it is.
	CP	':'		;Go around the loop again if it is a ':'.
	JR	Z,L1B28;STMT_LOOP

;A stmt has been identified so, 1st, its initial command is considered.
	LD	HL,L1B76	;Pre-load the machine stack with the
	PUSH	HL		;return addr - STMT_RET.
	LD	C,A		;Save the command temporarily
	RST	20H;NEXT_CHAR	;in the C reg whilst
	LD	A,C		;CH_ADD is advanced again.
	SUB	0CEH		;Reduce the command's code by 0CEh; giving
				;the range 00-31h for the fifty commands.
	JP	C,L1C8A;REPORT_C ;Give the appropriate error if not a
				;command code; Move the command code
	LD	C,A		;to the BC reg pair (B holds 00).
	LD	HL,L1A48	;The base addr of the syntax offset table.
	ADD	HL,BC		;The required offset is passed to the C reg
	LD	C,(HL)		;and used to compute the base addr for the
	ADD	HL,BC		;command's entries in the parameter table.
	JR	L1B55;GET_PARAM	;Jump forward into the scanning loop with
				;this addr.

;Each of the command class routines applicable to the present command are
;executed in turn. Any required separators are also considered.
L1B52:;SCAN_LOOP
	LD	HL,(L5C74);T_ADDR ;The temporary pntr to the entries in the
				;parameter table.
L1B55:;GET_PARAM
	LD	A,(HL)		;Fetch each entry in turn.
	INC	HL		;Update the pntr to the
	LD	(L5C74),HL;T_ADDR ;entries for the next pass.
	LD	BC,L1B52	;Pre-load the machine stack with the return
	PUSH	BC		;addr - SCAN_LOOP.
	LD	C,A		;Copy the entry to the C reg for later.
	CP	' '		;Jump forward if the entry is
	JR	NC,L1B6F;SEPARATOR ;a 'separator'.
	LD	HL,L1C01	;The base addr of the 'command class' table.
	LD	B,0		;Clear the B reg and
	ADD	HL,BC		;index into the table.
	LD	C,(HL)		;Fetch the offset and compute the starting
	ADD	HL,BC		;addr of the required command class routine.
	PUSH	HL		;Push the addr on to the machine stack.
	RST	18H;GET_CHAR	;Before making an indirect jump to the
	DEC	B		;command class routine pass the command code
	RET			;to the A rpeg and set the B reg to 0FFh.

;	THE 'SEPARATOR' SUBROUTINE
;The report - 'Nonsence in BASIC' is given if the required separator is not
;present. But note that when syntax is being checked the actual report
;does not appear on the screen - only the 'error marker'.
L1B6F:;SEPARATOR
	RST	18h;GET_CHAR	;The current char is fetched and compared
	CP	C		;to the entry in the parameter table.
	JP	NZ,L1C8A;REPORT_C ;Give the error report if there is not
	RST	20H;NEXT_CHAR	;a match. Step past a correct char and
	RET			;return.

;	THE 'STMT_RET' SUBROUTINE
;After the correct interpretation of a stmt a return is made to this entry
;point.
L1B76:;STMT_RET
	CALL	L1F54;BREAK_KEY	;The BREAK key is tested after every stmt.
	JR	C,L1B7D;STMT_R_1 ;Jump forward unless it has been pressed.

;Report L - 'BREAK into program'.
L1B7B:;REPORT_L
	RST	8;ERROR_1	;Call the error handling
	DB	14H		;routine.

;Continue here as the BREAK key was not pressed.
L1B7D:;STMT_R_1
	BIT	7,(IY+0AH);NSPPC ;Jump forward if there is not
	JR	NZ,L1BF4;STMT_NEXT ;a 'jump' to be made.
	LD	HL,(L5C42);NEWPPC ;Fetch the 'new line' number
	BIT	7,H		;and jump forward unless dealing with a
	JR	Z,L1B9E;LINE_NEW ;further stmt in the editing area.

;	THE 'LINE_RUN' ENTRY POINT
;This entry point is used wherever a line in the editing area is to be
;'run'. In such a case the syntax/run flag (bit 7 of FLAGS) will be set.
;  The entry point is also used in the syntax checking of a line in the
;editing area that has more than one stmt (bit 7 of FLAGS will be reset).
L1B8A:;LINE_RUN
	LD	HL,-2		;A line in the editing area
	LD	(L5C45),HL;PPC	;is considered as line '-2'.
	LD	HL,(L5C61);WORKSP ;Make HL point to the end
	DEC	HL		;marker of the editing area
	LD	DE,(L5C59);E_LINE ;and DE to the loc before
	DEC	DE		;the start of that area.
	LD	A,(L5C44);NSPPC	;Fetch the number of the next stmt to be
	JR	L1BD1;NEXT_LINE	;handled before jumping forward.

;	THE 'LINE_NEW' SUBROUTINE
;There has been a jump in the program and the starting addr of the new line
;has to be found.
L1B9E:;LINE_NEW
	CALL	L196E;LINE_ADDR	;The starting addr of the line, or the '1st
				;line after' is found.
	LD	A,(L5C44);NSPPC	;Collect the stmt number.
	JR	Z,L1BBF;LINE_USE ;Jump forward if the required
	AND	A		;line was found; otherwise
	JR	NZ,L1BEC;REPORT_N ;check the validity of the stmt number -
				;must be zero.
	LD	B,A		;Also check that the '1st line after'
	LD	A,(HL)		;is not after the actual
	AND	0C0H		;'end of program'.
	LD	A,B		;Jump forward with valid addresses;
	JR	Z,L1BBF;LINE_USE ;otherwise signal the error 'Ok'.

;Report 0 - 'Ok'
	RST	8;ERROR_1	;Use the error handling
	DB	0FFH		;routine.
;Note:Obviously not an error in the normal sense - but rather a jump past
;the program.

;	THE 'REM' COMMAND ROUTINE
;The return addr to STMT_RET is dropped which has the effect of forming
;the end of line to be ignored.
L1BB2:;REM
	POP	BC		;Drop the addr - STMT_RET.

;	THE 'LINE_END' ROUTINE
;If checking syntax a simple return is made but when 'running' the addr
;held by NXTLIN has to be checked before it can be used.
L1BB3:;LINE_END
	CALL	L2530;SYNTAX_Z	;Return if syntax is being checked.
	RET	Z
	LD	HL,(L5C55);NXTLIN ;otherwise test the addr in NXTLIN.
	LD	A,0C0H		;Return also if the addr is after the
	AND	(HL)		;end of the program - the 'run' is
	RET	NZ		;finished.
	XOR	A		;Signal 'stmt zero' before proceeding.

;	THE 'LINE_USE' ROUTINE
;This short routine has three functions: i. Change stmt zero to stmt '1';
;ii. Find the number of the new line and enter it into PPC; & iii. Form the
;addr of the start of the line after.
L1BBF:;LINE_USE
	CP	1		;Stmt zero becomes
	ADC	A,0		;stmt '1'.
	LD	D,(HL)		;The line number of the line
	INC	HL		;to be used is collected and
	LD	E,(HL)		;passed to PPC.
	LD	(L5C45),DE;PPC
	INC	HL		;Now find the 'length'
	LD	E,(HL)		;of the line.
	INC	HL
	LD	D,(HL)
	EX	DE,HL		;Switch over the values.
	ADD	HL,DE		;Form the addr of the start of the line
	INC	HL		;after in HL and the loc before new line's
				;1st char in DE.

;	THE 'NEXT_LINE' ROUTINE
;On entry the HL reg pair points to the loc after the end of the 'next' line
;to be handled and the DE reg pair to the loc before the 1st char of the
;line. This applies to lines in the program area and also to a line in the
;editing area - where the next line will be the same line again whilst there
;are still stmts to be interpreted.
L1BD1:;NEXT_LINE
	LD	(L5C55),HL;NXTLIN ;Set NXTLIN for use once the current line
				;has been completed.
	EX	DE,HL		;As usual CH_ADD points to the
	LD	(L5C5D),HL;CH_ADD ;loc before the 1st char to be considered.
	LD	D,A		;The stmt number is fetched.
	LD	E,0		;The E reg is cleared in case EACH_STMT
	LD	(IY+0AH),0FFH;NSPPC ;is used. Signal 'no jump'.
	DEC	D		;The stmt number minus
	LD	(IY+0DH),D;SUBPPC ;one goes into SUBPPC.
	JP	Z,L1B28;STMT_LOOP ;A 1st stmt can now be considered.
	INC	D		;However for later stmts the 'starting
	CALL	L198B;STMT_NEXT	;addr' has to be found. Jump forward
	JR	Z,L1BF4;STMT_NEXT ;unless the stmt does not exist.

;Report N - Statement lost
L1BEC:;REPORT_N
	RST	8;ERROR_1	;Call the error handling
	DB	16H		;routine.

;	THE 'CHECK_END' SUBROUTINE
;This is an important routine and is called from many places in the monitor
;program when the syntax of the edit-line is being checked. The purpose of
;the routine is to give an error report if the end of a stmt has not been
;reached and to move on to the next stmt if the syntax is correct.
L1BEE:;CHECK_END
	CALL	L2530;SYNTAX_Z	;Do not proceed unless
	RET	NZ		;checking syntax.
	POP	BC		;Drop the addr of SCAN_LOOP & STMT_RET
	POP	BC		;before continuing into STMT_NEXT

;	THE 'STMT_NEXT' ROUTINE
;If the present char is a 'carriage return' then the 'next stmt' is on
;the 'next line'; if ':' it is on the same line; but if any other char
;is found then there is an error in syntax.
L1BF4:;STMT_NEXT
	RST	18H;GET_CHAR	;Fetch the present char.
	CP	0DH		;Consider the 'next line' if it is
	JR	Z,L1BB3;LINE_END ;a 'carriage return'.
	CP	':'		;Consider the 'next stmt'
	JP	Z,L1B28;STMT_LOOP ;if it is a ':'. Otherwise there has
	JP	L1C8A;REPORT_C	;been a syntax error.

;	THE 'COMMAND CLASS' TABLE
L1C01:	
	DB	0FH	;CLASS-00	1C10
	DB	1DH	;CLASS-01	1C1F
	DB	4BH	;CLASS-02	1C4E
	DB	09H	;CLASS-03	1C0D
	DB	67H	;CLASS-04	1C6C
	DB	0BH	;CLASS-05	1C11
	DB	7BH	;CLASS-06	1C82
	DB	8EH	;CLASS-07	1C96
	DB	71H	;CLASS-08	1C7A
	DB	0B4H	;CLASS-09	1CBE
	DB	81H	;CLASS-0A	1C8C
	DB	0CFH	;CLASS-0B	1CDB

;	THE 'COMMAND CLASSES - 00, 03 & 05'
;The commands of class-03, or may not, be followed by a number, e.g. RUN
;& RUN 200.
L1C0D:;CLASS_03
	CALL	L1CDE;FETCH_NUM	;A number is fetched but zero is used
				;in cases of default.

;The commands of class-00 must not have any operands. e.g. COPY & CONTINUE.
L1C10:;CLASS_00
	CP	A		;Set the zero flag for later.

;The commands of class-05 may be followed by a set of items.
;e.g. PRINT & PRINT "222".
L1C11:;CLASS_05
	POP	BC		;In all cases drop the addr - SCAN_LOOP.
	CALL	Z,L1BEE;CHECK_END ;If handling commands of classes
				;00 & 03 AND syntax is being checked
				;move on now to consider the next stmt.
	EX	DE,HL		;Save the line pntr in the DE reg pair.

;	THE 'JUMP_C_R' ROUTINE
;After the command class entries and the separator entries in the parameter
;table have been considered the jump to the appropriate command routine
;is made.
L1C16:;JUMP_C_R
	LD	HL,(L5C74);T_ADDR ;Fetch the pntr to the
	LD	C,(HL)		;entries in the parameter table
	INC	HL		;and fetch the addr of the
	LD	B,(HL)		;required command routine.
	EX	DE,HL		;Exchange the pntrs back
	PUSH	BC		;and make an indirect jump
	RET			;to the command routine.

;	THE 'COMMAND CLASSES - 01, 02 & 04'
;These three command classes are used by the var handling commands - LET,
;FOR & NEXT and indirectly by READ & INPUT.
;  Command class 01 is concerned with the identification of the var in
;a LET, READ or INPUT stmt.
L1C1F:;CLASS_01
	CALL	L28B2;LOOK_VARS	;Look in the var area to determine whether
				;or not the var has been used already.

;	THE 'VARIABLE IN ASSIGNMENT' SUBROUTINE
;This subroutine develops the appropriate values for the system vars
;DEST & STRLEN.
L1C22:;VAR_A_1
	LD	(IY+37H),0;FLAGX ;Initialise FLAGX to 00. Jump forward if
	JR	NC,L1C30;VAR_A_2 ;the var has been used before.
	SET	1,(IY+37H);FLAGX ;Signal 'a new var'.
	JR	NZ,L1C46;VAR_A_3 ;Give an error if trying to use an
				 ;'undimensioned array'.

;Report 2 - Variable not found
L1C2E:;REPORT_2
	RST	8;ERROR_1	;Call the error handling
	DB	01H		;routine.

;Continue with the handling of existing vars.
L1C30:;VAR_A_2
	CALL	Z,L2996;STK_VARS ;The params of simple string vars and all
				;array vars are passed to the calculator
				;stack. (STK_VARS will 'slice' a string
				;if required.)
	BIT	6,(IY+01H);FLAGS ;Jump forward if handling a
	JR	NZ,L1C46;VAR_A_3 ;numeric var.
	XOR	A		;Clear the A reg.
	CALL	L2530;SYNTAX_Z	;The params of the string or string array
	CALL	NZ,L2BF1;STK_FETCH ;var are fetched unless syntax is being
	LD	HL,L5C71	;checked. This is FLAGX.
	OR	(HL)		;Bit 0 is set only when handling complete
	LD	(HL),A		;simple strings thereby signalling
				;'old copy to be deleted'.
	EX	DE,HL		;HL now points to the string or the element
				;of the array.

;The pathways now come together to set STRLEN & DEST as required. For all
;numeric vars and 'new' string & string array vars STRLEN-lo holds the
;'letter' of the var's name. But for 'old' string & string array vars
;whether 'sliced' or complete it holds the 'length' in 'assignment'.
L1C46:;VAR_A_3
	LD	(L5C72),BC	;Set STRLEN as required.

;DEST holds the addr for the 'destination' of an 'old' var but in effect
;the 'source' for a 'new' var.
	LD	(L5C4D),HL;DEST	;Set DEST as required and
	RET			;return.

;Command class 02 is concerned with the actual calculation of the value
;to be assignedin a LET stmt.
L1C4E:;CLASS_02
	POP	BC		;The addr - SCAN_LOOP is dropped.
	CALL	L1C56;VAL_FET_1	;The assignment is made.
	CALL	L1BEE;CHECK_END	;Move on to the next stmt either via
				;CHECK_END if checking syntax, or STMT_RET
	RET			;if in 'run-time'.

;	THE 'FETCH A VALUE' SUBROUTINE
;This subroutine is used by LET, READ & INPUT stmts to 1st evaluate and
;then assign values to the previously designated var.
;  The entry point VAL_FET_1 is used by LET & READ and considers FLAGS
;whereas the entry point VAL_FET_2 is used by INPUT and considers FLAGX.
L1C56:;VAL_FET_1
	LD	A,(L5C3B);FLAGS	;Use FLAGS.
L1C59:;VAL_FET_2
	PUSH	AF		;Save FLAGS or FLAGX.
	CALL	L24FB;SCANNING	;Evaluate the next expression.
	POP	AF		;Fetch the old FLAGS or FLAGX.
	LD	D,(IY+01H);FLAGS ;Fetch the new FLAGS.
	XOR	D		;The nature - numeric or string of the var
	AND	40h		;and the expression must match.
	JR	NZ,L1C8A;REPORT_C ;Give report C if they do not.
	BIT	7,D		;Jump forward to make the actual assignment
	JP	NZ,L2AFF;LET	;unless checking syntax when simply
	RET			;return.

;	THE 'COMMAND CLASS 04' ROUTINE
;The command class 04 entry point is used by FOR & NEXT stmts.
L1C6C:;CLASS_04
	CALL	L28B2;LOOK_VARS	;Look in the vars area for the var being
	PUSH	AF		;used. Save the AF reg pair whilst the
	LD	A,C		;discriminator byte is tested to ensure
	OR	9FH		;that the var is a FOR-NEXT control
	INC	A		;var.
	JR	NZ,L1C8A;REPORT_C
	POP	AF		;Restore the flags reg and jump back to
	JR	L1C22;VAR_A_1	;make the var that has been found the
				;'var in assignment'.

;	THE 'EXPECT NUMERIC/STRING EXPRESSIONS' SUBROUTINE
;There is a series of short subroutines that are used to fetch the result
;of evaluating the next expression. The result from a single expression
;is returned as a 'last value' on the calculator stack.
;  The entry point NEXT_2NUM is used when CH_ADD needs updating to point
;to the start of the 1st expression.
L1C79:;NEXT_2NUM
	RST	20H;NEXT_CHAR	;Advanced CH_ADD.

;The entry point EXPT_2NUM (EQU CLASS-08) allows for two numeric
;expressions, separated by a comma, to be evaluated.
L1C7A:;EXPT_2NUM (CLASS_08)
	CALL	L1C82;EXPT_1NUM	;Evaluate each expression in turn -
				;so evaluate the 1st.
	CP	','		;Give an error report if the
	JR	NZ,L1C8A;REPORT_C ;separator is not a comma.
	RST	20H;NEXT_CHAR	;Advance CH_ADD.

;The entry point EXPT_1NUM (EQU CLASS_06) allows for a single numeric
;expression to be evaluated.
L1C82:;EXPT_1NUM (CLASS_06)
	CALL	L24FB;SCANNING	;Evaluate the next expression.
	BIT	6,(IY+01H);FLAGS ;Return as long as the result was numeric;
	RET	NZ		;otherwise it is an error.

;Report C - Nonsence in BASIC
L1C8A:;REPORT_C
	RST	8;ERROR_1	;Call the error handling
	DB	0BH		;routine.

;The entry point EXPT_EXP (EQU CLASS-0A) allows for a single string
;expression to be evaluated.
L1C8C:;EXPT_EXP (CLASS_0A)
	CALL	L24FB;SCANNING	;Evaluate the next expression.
	BIT	6,(IY+01H);FLAGS ;This time return if the result indicates
	RET	Z		;a string; otherwise give an error
	JR	L1C8A;REPORT_C	;report.

;	THE 'SET PERMANENT COLOURS' SUBROUTINE (EQU CLASS_07)
;This subroutine allows for the current temporary colours to be made
;permanent. As command class 07 it is in effect the command routine for
;the six colour item commands.
L1C96:;PERMS (CLASS_07)
	BIT	7,(IY+01H);FLAGS ;The syntax/run flag is read.
	RES	0,(IY+02H);TV_FLAG ;Signal 'main screen'.
	CALL	NZ,L0D4D;TEMPS	;Only during a 'run' call TEMPS to ensure
				;the temporary colours are the main screen
				;colours.
	POP	AF		;Drop the return addr - SCAN_LOOP.
	LD	A,(L5C74);T_ADDR ;Fetch the low byte of T_ADDR and subtract
	SUB	13H		;13h to give the range 0D9h to 0DEh which
				;are the token codes for INK to OVER.
	CALL	L21FC;CO_TEMP_4	;Jump forward to change the temporary
				;colours as directed by the BASIC stmt.
	CALL	L1BEE;CHECK_END	;Move on to the next stmt if checking syntax.
	LD	HL,(L5C8F);ATTR_T ;Now the temporary colour values are
	LD	(L5C8D),HL;ATTR_P ;made permanent (both ATTR_P & MASK_P).
	LD	HL,L5C91	;This is P_FLAG; and that too
	LD	A,(HL)		;has to be considered.
;The following instructions cleverly copy the even bits of the supplied
;byte to the odd bits. In effect making the permanent bits the same as
;the temporary ones.
	RLCA			;Move the mask leftwards.
	XOR	(HL)		;Impress onto the mask
	AND	0AAH		;only the even bits of the
	XOR	(HL)		;other byte.
	LD	(HL),A		;Restore the result.
	RET

;	THE 'COMMAND CLASS 09' ROUTINE
;This routine is used by PLOT, DRAW & CIRCLE stmts in order to specify the
;default conditions of 'FLASH 8; BRIGHT 8; PAPER 8;' that are set up before
;any embedded colour items are considered.
L1CBE:;CLASS_09
	CALL	L2530;SYNTAX_Z	;Jump forward if
	JR	Z,L1CD6;CL_09_1	;checking syntax.
	RES	0,(IY+02H);TV_FLAG ;Signal 'main screen'.
	CALL	L0D4D;TEMPS	;Set the temporary colours for
				;the main screen.
	LD	HL,L5C90	;This is MASK_T.
	LD	A,(HL)		;Fetch its present value but
	OR	0F8H		;keep only its INK part 'unmasked'.
	LD	(HL),A		;Restore the value which now indicates
				;'FLASH 8;BRIGHT 8;PAPER 8;'.
	RES	6,(IY+57H);P_FLAG ;Also ensure NOT 'PAPER 9'.
	RST	18H;GET_CHAR	;Fetch the present char before continuing
				;to deal with embedded colour items.
L1CD6:;CL_09_1
	CALL	L21E2;CO_TEMP	;Deal with the locally dominant colour items.
	JR	L1C7A;EXPT_2NUM	;Now get the 1st two operands for PLOT,
				;DRAW or CIRCLE.

;	THE 'COMMAND CLASS 0B' ROUTINE
;This routine is used by SAVE, LOAD, VERIFY & MERGE stmts.
L1CDB:;CLASS_0B
	JP	L0605;SAVE_ETC	;Jump to the cassette handling routine.

;	THE 'FETCH A NUMBER' SUBROUTINE
;This subroutine leads to a following numeric expression being evaluated
;but zero being used instead if there is no expression.
L1CDE:;FETCH_NUM
	CP	0DH		;Jump forward if at the end
	JR	Z,L1CE6;USE_ZERO ;of a line.
	CP	':'		;But jump to EXPT_1NUM unless
	JR	NZ,L1C82;EXPT_1NUM ;at the end of a stmt.

;The calculator is now used to add the value zero to the calculator stack.
L1CE6:;USE_ZERO
	CALL	L2530;SYNTAX_Z	;Do not perform the operation
	RET	Z		;if syntax is being checked.
	RST	28H;FP_CALC	;Use the calculator.
	DB	0A0H;stk_zero	;The 'last value' is now zero.
	DB	38H;end_calc
	RET			;Return with zero added to the stack.

