
;	RAM allocation by Spectrum ROM.

L4000	EQU	4000H	;start of display area
L5800	EQU	5800H	;start of attribute area
L5AC0	EQU	5AC0H	;attr byte at start of line 22
L5AE0	EQU	5AE0H	;attr byte at start of line 23 (bottom)

L5B00	EQU	5B00H	;Printer buffer (100h)

L5C00	EQU	5C00H	;KSTATE0 (4)
L5C04	EQU	5C04H	;KSTATE4 (4)
L5C08	EQU	5C08H	;LAST_K
L5C09	EQU	5C09H	;REPDEL
L5C0A	EQU	5C0AH	;REPPER
L5C0B	EQU	5C0BH
L5C0C	EQU	5C0CH
L5C0D	EQU	5C0DH	;K_DATA
L5C0E	EQU	5C0EH	;TV_DATA (2)
L5C0F	EQU	5C0FH
L5C10	EQU	5C10H
L5C16	EQU	5C16H
L5C36	EQU	5C36H	;CHARS (2)
L5C38	EQU	5C38H
L5C3A	EQU	5C3AH	;ERR_NR (base at IY)
L5C3B	EQU	5C3BH	;FLAGS
L5C3C	EQU	5C3CH	;TV_FLAG
L5C3D	EQU	5C3DH	;ERR_SP (2)
L5C3F	EQU	5C3FH	;LLIST_SP (2)
L5C41	EQU	5C41H	;MODE
L5C42	EQU	5C42H
L5C44	EQU	5C44H
L5C45	EQU	5C45H
L5C47	EQU	5C47H
L5C48	EQU	5C48H	;BORDCR
L5C49	EQU	5C49H	;E_PPC (2)
L5C4A	EQU	5C4AH
L5C4B	EQU	5C4BH	;VARS (2)
L5C4D	EQU	5C4DH
L5C4F	EQU	5C4FH	;CHANS (2)
L5C51	EQU	5C51H	;CURCHL (1)
L5C53	EQU	5C53H	;PROG (2)
L5C55	EQU	5C55H
L5C57	EQU	5C57H	;DATADD (2)
L5C59	EQU	5C59H	;E_LINE (2)
L5C5B	EQU	5C5BH	;K_CUR (2)
L5C5D	EQU	5C5DH	;CH_ADD (2)
L5C5F	EQU	5C5FH	;X_PTR (2)
L5C61	EQU	5C61H	;WORKSP (2)
L5C63	EQU	5C63H	;STKBOT (2)
L5C65	EQU	5C65H	;STKEND (2)
L5C66	EQU	5C66H
L5C67	EQU	5C67H
L5C68	EQU	5C68H
L5C6A	EQU	5C6AH	;FLAGS2
L5C6B	EQU	5C6BH	;DF_SZ
L5C6C	EQU	5C6CH
L5C6E	EQU	5C6EH
L5C70	EQU	5C70H
L5C71	EQU	5C71H	;FLAGX
L5C72	EQU	5C72H
L5C74	EQU	5C74H
L5C76	EQU	5C76H
L5C78	EQU	5C78H	;FRAMES (3)
L5C7B	EQU	5C7BH	;UDG (2)
L5C7D	EQU	5C7DH	;COORDS (2)
L5C7E	EQU	5C7EH
L5C80	EQU	5C80H	;PR_CC (2)
L5C82	EQU	5C82H	;ECHO_E
L5C84	EQU	5C84H	;DF_CC (2)
L5C86	EQU	5C86H	;DF_CCL (2)
L5C88	EQU	5C88H	;S_POSN
L5C89	EQU	5C89H	;S_POSN+1
L5C8A	EQU	5C8AH	;S_POSNL
L5C8B	EQU	5C8BH	;S_POSNL+1
L5C8C	EQU	5C8CH	;SCR_CT
L5C8D	EQU	5C8DH	;ATTR_P (2)
L5C8F	EQU	5C8FH	;ATTR_T (2)
L5C90	EQU	5C90H
L5C91	EQU	5C91H	;P_FLAG
L5C92	EQU	5C92H	;MEMBOT (2)
L5CA1	EQU	5CA1H
L5CA6	EQU	5CA6H
L5CAA	EQU	5CAAH
L5CAB	EQU	5CABH
L5CAC	EQU	5CACH
L5CB0	EQU	5CB0H	;NMIADD (2)
L5CB2	EQU	5CB2H	;RAMTOP (2)
L5CB4	EQU	5CB4H	;P_RAMT (2)
L5CB6	EQU	5CB6H
L5CDA	EQU	5CDAH

